#include <stdio.h>
/* ++pac */
#ifndef _PLAN9
#include <malloc.h>
#endif


/* allocate vector of type float with indices that run from 0 to high */
float *fvec(high)
int high;
{
	float *hold;
	hold=(float *)malloc((unsigned) (high+1)*sizeof(float));
	if (!hold) printf("Allocation error in fvec()\n");
	return hold;
}

/* free vector of type float with indices that run from 0 to high */
void freefvec(vecname)
float *vecname;
{
   free((char*) (vecname));
}

/* allocate vector of type double with indices that run from 0 to high */
double *dvec(high)
int high;
{
	double *hold;
	hold=(double *)malloc((unsigned) (high+1)*sizeof(double));
	if (!hold) printf("Allocation error in dvec()\n");
	return hold;
}

/* free vector of type double with indices that run from 0 to high */
void freedvec(vecname)
double *vecname;
{
   free((char*) (vecname));
}

/* allocate vector of type int with indices that run from 0 to high */
int *ivec(high)
int high;
{
	int *hold;
	hold=(int *)malloc((unsigned) (high+1)*sizeof(int));
	if (!hold) printf("Allocation error in ivec()\n");
	return hold;
}

/* free vector of type float int with indices that run from 0 to high */
void freeivec(vecname)
int *vecname;
{
   free((char*) (vecname));
}

/* allocate float matrix with indices that run 0->highrow, 0-> highcol */
float **fmat(highrow,highcol)
int highrow, highcol;
{
   int ktrack;
   float **hold;
   hold =(float **) malloc((unsigned) (highrow+1)*sizeof(float*));
   if (!hold) printf("Allocation Failure in fmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(float *) malloc((unsigned) (highcol+1)*sizeof(float));
      if (!hold[ktrack]) printf("Allocation Failure in fmat()\n");
   }
   return hold;
}

/* free float matrix with indices that run 0->highrow, 0-> highcol */
void freefmat(matname,highrow,highcol)
float **matname;
int highrow, highcol;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}

/* allocate double matrix with indices that run 0->highrow, 0-> highcol */
double **dmat(highrow,highcol)
int highrow, highcol;
{
   int ktrack;
   double **hold;
   hold =(double **) malloc((unsigned) (highrow+1)*sizeof(double*));
   if (!hold) printf("Allocation Failure in dmat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(double *) malloc((unsigned) (highcol+1)*sizeof(double));
      if (!hold[ktrack]) printf("Allocation Failure in dmat()\n");
   }
   return hold;
}

/* free double matrix with indices that run 0->highrow, 0-> highcol */
void freedmat(matname,highrow,highcol)
double **matname;
int highrow, highcol;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}

/* allocate int matrix with indices that run 0->highrow, 0-> highcol */
int **imat(highrow,highcol)
int highrow, highcol;
{
   int ktrack;
   int **hold;
   hold =(int **) malloc((unsigned) (highrow+1)*sizeof(int*));
   if (!hold) printf("Allocation Failure in imat()\n");
   for(ktrack=0; ktrack<= highrow; ktrack++)
   {
      hold[ktrack]=(int *) malloc((unsigned) (highcol+1)*sizeof(int));
      if (!hold[ktrack]) printf("Allocation Failure in imat()\n");
   }
   return hold;
}

/* free int matrix with indices that run 0->highrow, 0-> highcol */
void freeimat(matname,highrow,highcol)
int **matname;
int highrow, highcol;
{
   int ktrack;
   for(ktrack=highrow;ktrack>=0;ktrack--) free((char*) (matname[ktrack]));
   free((char*) (matname));
}
