 
/* (c) Copyright 1993 by Jeff Thorne.  This program can be copied as long as
   this message is not deleted and the program is distributed free of charge */
 
#include<stdio.h>
#include<math.h>
#include "common.h"
#ifdef PROT

#include "prottg.h"


/* density when insertion-deletion process parameters and replacement 
   process parameters are constrained to be in certain proportions.  This
   is junky programming but hopefully correct */
double 
fconspam(thispar,parflag,othpar,fstat,sstat,othstat)
double thispar,othpar, **fstat, **sstat, *othstat;
int parflag;
{
   double thedens;
   extern double fmulmu();
   extern double fpam();

   thedens  = fpam(thispar,parflag,thispar*othstat[10],fstat,sstat, othstat);
   thedens += fpam(thispar*othstat[8],parflag,thispar*othstat[10]*othstat[8] ,
                   sstat,fstat, othstat);
   thedens += fmulmu(othstat[7], -1*parflag, othstat[9]*thispar, 
                     fstat,sstat,othstat);
   return(thedens);
}

#else

#include "dna.h"

/* density when insertion-deletion process parameters and substitution
   process parameters are constrained to be in certain proportions.  This
   is junky programming but hopefully correct */
double 
fconsdna(thispar,parflag,othpar,fstat,sstat,othstat)
double thispar,othpar, **fstat, **sstat, *othstat;
int parflag;
{
   double thedens;

   extern double fmulmu();
   extern double fsub();
   thedens  = fsub(thispar,parflag,thispar*othstat[10],fstat,sstat, othstat);
   thedens += fsub(thispar*othstat[8],parflag,thispar*othstat[10]*othstat[8] ,
                   sstat,fstat, othstat);
   thedens += fmulmu(othstat[7], -1*parflag, othstat[9]*thispar, 
                     fstat,sstat,othstat);
   return(thedens);
}

#endif

void 
docons(seq,pars,estim,mask,name1,name2) /* estimates "general" substitution
                                    rate as only free parameter - all other
                                    parameters are either fixed or proportional
                                    to the "general" substitution parameter */
int **seq, *estim;
char *name1, *name2; /* names of the 2 sequences being analyzed */
double *pars, **mask;
{
   double **holdtg,**hold[7];
   int ktrack,**holdee;
   int dum1,dum2,stopflag,nseqs;
   FILE *thisfar; /* a file that tells which sequences are being analyzed */
   FILE *distfile; /* file with the distances and std errors */
   FILE *testseq; /* file with the sequences of interest */
   int numits;  /* number of iterations of EM routine */
   double gtol; /* How accurate should specific parameter estimates be for a
                   given set of statistics */
   double newhood,oldhood;
   double **f,**fastf; /* slow substitution probs., fast substitution probs.
                          Both multiplied by probability of initial a.a. */
   double **fstat,**sstat; /* EM statistics for fast and slow substitutions */
   double *othstat; /* the other "EM" statistics */
   double const2;
   double hihood,lowhood,standerror,inc;
#ifndef PROT
   double const7;
#endif
   int numsamps;
   extern double dubsum();
   extern double gsearch(); /* golden section search */
   extern void expect(); /* E part of EM */
   extern void expectps();
   extern double **dmat();
   extern int **imat();
   extern double *dvec();
   extern void freedvec();
   extern void freeimat();
   extern void freedmat();

#ifdef PROT
   extern double fconspam(); /* constrained density for protein sequences */

   othstat=dvec(9); /* Cheap Fix: 1...6 are indel stats, 7 is (lambda/mu ), 
                      8 is kfast, 9 is const2=(mu/genrate) */

#else
   extern double fconsdna(); /* constrained density for DNA sequences */
   othstat=dvec(10); /* Cheap Fix: 1...6 are indel stats, 7 is (lambda/mu ), 
                      8 is kfast, 9 is const2=(mu/genrate),
                      10 is const7= (wigrate/genrate) */

#endif

   othstat[7]=pars[0];
   othstat[8]=pars[5];
   const2= pars[2]/pars[1];
   othstat[9]=const2;
   printf("Constraints are active !! The values of (lambda/mu), r,\n");
   printf("pfast, kfast are fixed.  The value of mu is forced to be\n");
   printf("%12.8f times the value of genrate.\n", const2);
#ifndef PROT
   const7=pars[7]/pars[1];
   othstat[10]=const7;
   printf("The value of wigrate is %12.8f times the value of genrate.\n",
           const7);
#endif
   printf("\n");

   numsamps =seq[0][0]/SAMPFREQ;
   if ((seq[0][0] % SAMPFREQ) == 0) numsamps--;
   f=dmat(NUMLETTERS,NUMLETTERS);
   fastf=dmat(NUMLETTERS,NUMLETTERS);
   fstat=dmat(NUMLETTERS,NUMLETTERS);
   sstat=dmat(NUMLETTERS,NUMLETTERS);
   holdtg=dmat(3,max2(seq[0][0],seq[1][0])+1);
   for (ktrack=0;ktrack<7;ktrack++)
   {
      hold[ktrack]=dmat(numsamps,seq[1][0]);
   }
   holdee=imat(numsamps,seq[1][0]);

   gtol= LTOL/10.0;
   oldhood= -1.0*BIGNUM;
   newhood= -0.5*BIGNUM;
   numits=0;

   printf("The output below is the number of EM cycles thus far\n");
   printf("followed by the current parameter estimates:\n");
   while(newhood-oldhood > LTOL)
   {
      oldhood=newhood;
      printf("%3d genrate=%8.4f mu=%6.4f r=%6.4f pfast=%6.4f kfast=%6.3f",
      numits,pars[1],pars[2],pars[3],pars[4],pars[5]);
      printf(" tgap=%6.4f\n", pars[6]);
#ifndef PROT
      printf("wigrate= %7.5f\n", pars[7]);
#endif
      newhood= -dubsum(holdtg,hold, holdee,f,fastf,seq,pars);
      printf("newhd= %11.9E oldhd= %11.9E", newhood,oldhood);
      printf(" (lambda/mu =%6.4f)\n", pars[0]);
      expect(holdtg,hold, holdee,pars,f, fastf,seq,fstat,sstat,othstat);
      if(estim[6]==0 && pars[6] <= mask[6][0] && pars[6] >= mask[6][1])
      {
         pars[6]= othstat[6]/(2.0+othstat[6]);
      }
   
#ifdef PROT
      pars[1]=gsearch(0.5*pars[1],pars[1]+0.005, 0.01+
                    1.5*pars[1],fconspam, -1*seq[0][0] - seq[1][0],
                    0.0,fstat,sstat,othstat,gtol);
#else
      pars[1]=gsearch(0.5*pars[1],pars[1]+0.005, 0.01+
                    1.5*pars[1],fconsdna, -1*seq[0][0] - seq[1][0],
                    0.0,fstat,sstat,othstat,gtol);
      pars[7]=pars[1]*const7;
#endif
      pars[2]=pars[1]*const2;
      numits++;
   }

   newhood= -dubsum(holdtg,hold, holdee,f,fastf,seq,pars);
   
   /* calculate second derivative for 
      approximate standard error - beginning here */
   inc= 0.01*pars[1];
   pars[1] += inc;
   pars[2]=pars[1]*const2;
#ifndef PROT
   pars[7]=pars[1]*const7;
#endif
   hihood= -dubsum(holdtg,hold, holdee,f,fastf,seq,pars);

   pars[1] -= 2.0*inc;
   pars[2]=pars[1]*const2;
#ifndef PROT
   pars[7]=pars[1]*const7;
#endif

   lowhood= -dubsum(holdtg,hold, holdee,f,fastf,seq,pars);
   
   pars[1] += inc;
   pars[2]=pars[1]*const2;
#ifndef PROT
   pars[7]=pars[1]*const7;
#endif
   
   standerror= sqrt(-inc*inc/(hihood-2.0*newhood+lowhood));

   printf("newhd= %11.9E oldhd= %11.9E\n", newhood,oldhood);

   /* now send arc probabilities to output file, later to be turned into
      postscript */
   expectps(holdtg,hold, holdee,pars,f, fastf,seq,fstat,sstat,othstat);

   printf("\n%3d EM iterations were required before log-likelihood was\n", 
           numits);
   printf("not improved by at least %8.4E between successive EM ", LTOL);
   printf("iterations\n" ); 
   printf("gtol=%8.4E (criterion for terminating ", gtol);
   printf("M-step of given EM iteration)\n\n");
   printf("FINAL PARAMETER ESTIMATES:\n");
   printf("lmuratio= %9.6E (lambda= %6.4E)\n",pars[0], pars[0]*pars[2]);
   printf("genrate= %9.6E std error= %9.6E\n", pars[1], standerror);
   printf("mu=%9.6E r=%9.6E pfast=%9.6E kfast=%9.6E tgap=%9.6E\n", 
           pars[2],pars[3],pars[4],pars[5],pars[6]);

   
   thisfar= fopen("thisfar", "r");
   fscanf(thisfar,"%d%d%d", &dum1, &dum2, &stopflag);
   fclose(thisfar);

   testseq = fopen("testseq","r");
   fscanf(testseq,"%d", &nseqs);
   fclose(testseq);

   if (dum1==1 && dum2==2)
   {
      distfile= fopen("seqs.dist", "w");
      fprintf(distfile,"%d\n", nseqs);
   }
   else
   {
      distfile= fopen("seqs.dist", "a");
   }
   if (dum2== dum1+1)
   {
      for(ktrack=0;ktrack <=9; ktrack++)
      {
         fprintf(distfile,"%1c", name1[ktrack]);
      }
      fprintf(distfile," ");
   }
      
   fprintf(distfile, "%.4f %.4f", pars[1], standerror);
   if (dum2==nseqs)
   {
      fprintf(distfile,"\n");
      if (dum1==dum2-1)
      {
         for(ktrack=0;ktrack<=9;ktrack++)
         {
            fprintf(distfile,"%1c", name2[ktrack]);
         }
         fprintf(distfile,"\n");
      }
   }
   else
   {
      fprintf(distfile, " ");  
   }

   fclose(distfile);

#ifndef PROT
   printf("wigrate= %9.6E\n", pars[7]);
#endif
   printf("\nFINAL log-likelihood= %12.10E (", newhood);
   printf("sum over all alignments)\n");

#ifdef PROT
   freedvec(othstat,9);
#else
   freedvec(othstat,10);
#endif

   freedmat(fstat,NUMLETTERS,NUMLETTERS);
   freedmat(sstat,NUMLETTERS,NUMLETTERS);
   freedmat(fastf,NUMLETTERS,NUMLETTERS);
   freedmat(f,NUMLETTERS,NUMLETTERS);
   for (ktrack=0;ktrack<7;ktrack++)
   {
      freedmat(hold[ktrack],numsamps,seq[1][0]);
   }
   freedmat(holdtg,3,max2(seq[0][0],seq[1][0])+1);
   freeimat(holdee,numsamps,seq[1][0]);
}

