 
/* (c) Copyright 1993 by Jeff Thorne.  This program can be copied as long as
   this message is not deleted and the program is distributed free of charge */
 
#include <stdio.h>
#ifdef PROT
#include "prottg.h"
#else
#include "dna.h"
#endif

void 
domask(pars,estim,mask) 
/* Read the file that tells which parameters are to be estimated */
int *estim; /* if estim[i]=0 then estimate parameter i, else keep it fixed */ 
double **mask; /* don't take derivatives with respect to parameter i if 
                  final value of parameter i is higher than mask[i][0] or
                  lower than mask[i][1] */
double *pars; /* contains parameter values - initial values read in here */
{
   int ktrack1, parnum;
   FILE *maskfile;
  
#ifdef PROT
   maskfile=fopen("protmask.dat", "r");
#else
   maskfile=fopen("dnamask.dat","r");
#endif

   while(getc(maskfile) != '\n');
   for(ktrack1=0;ktrack1<=NPARAMS;ktrack1++)
   {
      fscanf(maskfile, "%d", &parnum);
      fscanf(maskfile, "%d", &estim[parnum]);
      fscanf(maskfile, "%lf%lf%lf", &mask[parnum][0], &mask[parnum][1], 
      &pars[parnum]);
      while(getc(maskfile) != '\n');
   } 
   fclose(maskfile);
}
