 
/* (c) Copyright 1993 by Jeff Thorne.  This program can be copied as long as
   this message is not deleted and the program is distributed free of charge */
 
#include <stdio.h>
#include "common.h"

#ifdef PROT

char 
tobase( thisbase) 
/* Take integer code for an amino acid and return character code */
int thisbase;
{
  switch (thisbase){
     case 0: return('G');
        break;
     case 1: return('A');
        break;
     case 2: return('V');
        break;
     case 3: return('L');
        break;
     case 4: return('I');
        break;
     case 5: return('M');
        break;
     case 6: return('F');
        break;
     case 7: return('P');
        break;
     case 8: return('S');
        break;
     case 9: return('T');
        break;
     case 10: return('C');
        break;
     case 11: return('N');
        break;
     case 12: return('Q');
        break;
     case 13: return('Y');
        break;
     case 14: return('W');
        break;
     case 15: return('D');
        break;
     case 16: return('E');
        break;
     case 17: return('H');
        break;
     case 18: return('K');
        break;
     case 19: return('R');
        break;
     case 20: return('?');
        break;
     default: printf("ERROR2 !!\n");
        return('!');
        break;
  }
}

int 
frombase(basechar) 
/* take character code for an amino acid and return integer code */
char basechar;
{
  int whichamino;

  switch ( basechar )
  {
      case 'G' :  whichamino=0;
         break;
      case 'A' :  whichamino=1;
         break;
      case 'V' :  whichamino=2;
         break;
      case 'L' :  whichamino=3;
         break;
      case 'I' :  whichamino=4;
         break;
      case 'M' :  whichamino=5;
         break;
      case 'F' :  whichamino=6;
         break;
      case 'P' :  whichamino=7;
         break;
      case 'S' :  whichamino=8;
         break;
      case 'T' :  whichamino=9;
         break;
      case 'C' :  whichamino= 10;
         break;
      case 'N' :  whichamino= 11;
         break;
      case 'Q' :  whichamino= 12;
         break;
      case 'Y' :  whichamino= 13;
         break;
      case 'W' :  whichamino= 14;
         break;
      case 'D' :  whichamino= 15;
         break;
      case 'E' :  whichamino= 16;
         break;
      case 'H' :  whichamino= 17;
         break;
      case 'K' :  whichamino= 18;
         break;
      case 'R' :  whichamino= 19;
         break;
      case '?' :  whichamino= 20;
         break;
      default :   whichamino= 99;
         break;
   }
   return(whichamino);
}

#else

char 
tobase( thisbase) 
/* take integer code for base, return character code */
int thisbase;
{
  switch (thisbase){
     case 0: return('A');
        break;
     case 1: return('G');
        break;
     case 2: return('T');
        break;
     case 3: return('C');
        break;
     case 4: return('?');
        break;
     default: printf("ERROR2 !!\n");
        return('!');
        break;
  }
}

int 
frombase(basechar) 
/* take character code for base, return integer code */
char basechar;
{
  int whichbase;
 
  switch ( basechar )
  {
      case 'A' :  whichbase=0;
         break;
      case 'G' :  whichbase=1;
         break;
      case 'T' :  whichbase=2;
         break;
      case 'C' :  whichbase=3;
         break;
      case '?' :  whichbase=4;
         break;
      default:    whichbase=99; 
         break;
   }
   return(whichbase);
}

#endif

void 
readseq(seq,name1,name2) 
                  /* this procedure reads in the data from a formatted file 
                     It reads the first two sequences in the file.  It
                     waits for a '>' character and then 2 carriage returns
                     (i.e. '\n') before reading in the sequence.  The sequence
                     is terminated with an asterisk */
int **seq;
char *name1, *name2; /* names of the 2 sequences */
{
  int frombase();
  FILE *f;
  FILE *thisfar;
  char c;
  int thislength,whichseq;
  int ktrack1,ktrack2,ttrack;

  f=fopen("testseq","r");
  for(ktrack1=0;ktrack1<10;ktrack1++)
  {
     name1[ktrack1]= '_';
     name2[ktrack1]= '_';
  }

  thisfar=fopen("thisfar", "r");
  fscanf(thisfar, "%d%d", &ktrack1, &ktrack2);
  fclose(thisfar);
  for(whichseq=0;whichseq<=1; whichseq++)
  {
     if (whichseq==0)
     {
        for(ttrack=1;ttrack< ktrack1;ttrack++)
        {
           while (getc(f) != '>');
        }
     }
     else
     {
        for(ttrack=ktrack1+1;ttrack < ktrack2;ttrack++)
        {
            while (getc(f) != '>');
        }
     } 
     ttrack=0; 
     thislength=0;
     while (getc(f) !='>');
     while ( getc(f) != '\n');
     c=getc(f);
     while ( c != '\n' && ttrack <80)
     {
        if (whichseq==0)
        {
           name1[ttrack]=c;
        }
        else
        {
           name2[ttrack]=c;
        }
        ttrack++;
        c=getc(f);
     }
     if (whichseq==0)
     {
        name1[max2(10,ttrack)] = '\n';
     }
     else
     {
        name2[max2(10,ttrack)] = '\n';
     }
     if (ttrack==80 && c != '\n')
     {
        while ( getc(f) != '\n');
     }      
     while ( (c=getc(f)) != '*') 
     {
        if ( frombase(c) != 99)
        {
           thislength++;
           seq[whichseq][thislength]= frombase(c);
        }
     }
     if (whichseq==0) 
        seq[0][0]=thislength;
     else 
        seq[1][0]=thislength;
     while ( getc(f) != '\n');
  }
  fclose(f);
  printf("\n");
  printf("Sequences %2d and %2d from file testseq will be compared\n",
          ktrack1,ktrack2);
  printf("The former sequence has length %5d and name:\n",seq[0][0]);
  ttrack=0;
  c= ' ';
  while (c != '\n')
  {
     c= name1[ttrack];
     printf("%1c",c);
     ttrack++;
  }
  printf("\n");
  printf("The latter sequence has length %5d and name:\n",seq[1][0]);
  ttrack=0; 
  c= ' '; 
  while (c != '\n')
  { 
     c= name2[ttrack];
     printf("%1c",c);
     ttrack++; 
  }

  printf("\n\n");
}

