 
/* (c) Copyright 1993 by Jeff Thorne.  This program can be copied as long as
   this message is not deleted and the program is distributed free of charge */
 
#include <math.h>
#include <stdio.h>
#include "common.h"
#ifdef PROT
#include "prottg.h"
#else
#include "dna.h"
#endif

extern double bfrq[NUMLETTERS+1];
/* fills in specified portion of full likelihood (i.e. all alignments summed )
   matrix.  requires precalculated columns of the matrix  - the code is
   very similar to the dosum() routine */
void 
recreate(holdtg,filltg,prvec,f,fastf,seq,hold,bee, bstart,fill,pee)
double **holdtg,**filltg,**f,**fastf,*prvec;
double **hold[7] ,**fill[];
int **seq,bstart, **bee, **pee;
{
   extern double *dvec();
   extern int *ivec();
   extern void freedvec();
   extern void freeivec();

   double old1,old2,old4,old5,old7,rold1,rold4,rold7;
   double specidterm,spec3term,oldsum,roldsum;
   double *sf1,*sf2,*sf3,*sf4,*sf5,*sf6,*sf7,*sum;
   double *lsf1,*lsf2,*lsf3,*lsf4,*lsf5,*lsf6,*lsf7,*lsum;
   double tg1,tg2,tg3,*ltg0,*tg0;
   double fasthold,fhold,pi1hold,pi2hold,magnify,micronum,microfy;
   double tsum,tgap,r,p1term,idterm,fsterm,bdterm;
   int eemax,s1hold,s2hold,*ee,*lee,eemin,oldee1,oldee2,oldee3;
   int high1,twojumps,s1track,s2track,flag1,flag2;
   int seqlength1,seqlength2,s1place;

   r=prvec[0];
   p1term=prvec[1];
   idterm=prvec[2];
   fsterm=prvec[3];
   bdterm=prvec[4];
/* limmterm=prvec[5] */
   tgap=prvec[6];
   seqlength2=seq[1][0];
   seqlength1=seq[0][0];
   if (bstart==0)
   {
      ltg0=dvec(seqlength2);
   }
   lsf1=dvec(seqlength2);
   lsf2=dvec(seqlength2);
   lsf3=dvec(seqlength2);
   lsf4=dvec(seqlength2);
   lsf5=dvec(seqlength2);
   lsf6=dvec(seqlength2);
   lsf7=dvec(seqlength2);
   lsum=dvec(seqlength2);
   lee= ivec(seqlength2);
   magnify= exp(1.0*JUMP);
   micronum= exp(-1.0*JUMP);
   sf1= lsf1;
   sf2=lsf2;
   sf3=lsf3;
   sf4=lsf4;
   sf5=lsf5;
   sf6=lsf6;
   sf7=lsf7;
   ee=lee;
   sum= lsum;
   for(s2track=0;s2track<=seqlength2;s2track++)
   {
      *ee=  bee[bstart][s2track];
      *sf1= hold[0][bstart][s2track];
      *sf2= hold[1][bstart][s2track];
      *sf3= hold[2][bstart][s2track];
      *sf4= hold[3][bstart][s2track];
      *sf5= hold[4][bstart][s2track];
      *sf6= hold[5][bstart][s2track];
      *sf7= hold[6][bstart][s2track];
      *sum= *sf1+ *sf2 + *sf3 + *sf4 + *sf5 + *sf6 + *sf7;
      if (s2track==0)
      {
         tg1= holdtg[1][bstart];
         filltg[0][0]= tg1;
         *sum += tg1;
         if (bstart==0) 
            tg0=ltg0;
      }
      else
      {
         if (s2track==seqlength2)
         {
            tg2= holdtg[2][bstart];
            filltg[1][0]= tg2;
         }
      }
      if (bstart==0)
      {
         *tg0 = holdtg[0][s2track];
         *sum += *tg0;   
         tg0++;
      }
      pee[0][s2track]= *ee;
      fill[0][0][s2track]= *sf1;
      fill[1][0][s2track]= *sf2;
      fill[2][0][s2track]= *sf3;
      fill[3][0][s2track]= *sf4;
      fill[4][0][s2track]= *sf5;
      fill[5][0][s2track]= *sf6;
      fill[6][0][s2track]= *sf7;
      ee++;
      sf1++;
      sf2++;
      sf3++;
      sf4++;
      sf5++;
      sf6++;
      sf7++;
      sum++;
   }

   specidterm= r+ idterm;
   magnify *= magnify;
   microfy= 1.0/magnify;
   twojumps= JUMP+JUMP;
   if (seqlength1 <= (bstart+1)*SAMPFREQ) 
   {
      high1=seqlength1;
   }
   else 
      high1= (bstart+1)*SAMPFREQ-1;


   for(s1track=(bstart*SAMPFREQ)+1;s1track<=high1;s1track++)
   {
      s1place= s1track-bstart*SAMPFREQ;
      s1hold=seq[0][s1track];
      pi1hold= bfrq[s1hold];
      if (s1track==1) 
         flag1=0;
      else 
         flag1=1;
      rold4= *lsf4;
      rold1= *lsf1;
      if (flag1) 
         rold7= *lsf7;
      else 
         rold7= rold1;
      oldee1 = *lee;
      if (flag1) 
      {
         *lsf2 = (tg1*idterm+ *lsf2*specidterm) *pi1hold;
         tg1 *= pi1hold*tgap;
      }
      else
      {   
         *lsf2 = *ltg0 *pi1hold* idterm;
         tg1 =  *ltg0*pi1hold*tgap*0.5;
      }

      oldsum= *lsum;
      *lsum= *lsf2+tg1;
      if (*lsum< micronum)
      {
         tg1 *= magnify;
         *lsf2 *= magnify;
         *lsum *= magnify;
         *lee += twojumps;
      }

      *lsf1= 0.0;
      *lsf3= 0.0;
      *lsf4= 0.0;
      *lsf5= 0.0;
      *lsf6= 0.0;
      *lsf7= 0.0;
      ee=lee;
      sum=lsum;
      sf1=lsf1;
      sf2=lsf2;
      sf3=lsf3;
      sf4=lsf4;
      sf5=lsf5;
      sf6=lsf6;
      sf7=lsf7;
      for(s2track=1;s2track<=seqlength2;s2track++)
      {
         sf1++;
         sf2++;
         sf3++;
         sf4++;
         sf5++;
         sf6++;
         sf7++;
         sum++;
         ee++;
         old1= *sf1;
         old2 = *sf2;
         old4= *sf4;
         old5 = *sf5;
         old7= *sf7;
         oldee2= *ee;
         oldee3= *(ee-1);
         roldsum=oldsum;
         oldsum= *sum;
         if (s2track==1) 
            flag2=0;
         else 
            flag2=1;
         s2hold=seq[1][s2track];
         pi2hold= bfrq[s2hold];
         fhold= f[s1hold][s2hold];
         fasthold=fastf[s1hold][s2hold];

         if (flag1 && flag2) 
         {
            *sf1 = fhold*(roldsum*p1term+rold1*r);
            *sf4 = pi2hold*pi1hold*(roldsum*bdterm+rold4*r*r);
            *sf7 = fasthold*(roldsum*fsterm+rold7*r);
         }
         else
         {
            *sf1 = fhold* roldsum * p1term;
            *sf4 = pi2hold *pi1hold*roldsum*bdterm;
            *sf7 = fasthold* roldsum * fsterm;
         }
         if (flag1) 
         {
            *sf2= pi1hold*(oldsum*idterm+old2*r);
            *sf5= pi1hold*r*(old5 + old4);
         }
         else 
         {
            *sf5= 0.0;
            *sf2= pi1hold*oldsum*idterm;
         }
  
        spec3term= *(sum-1)-  *(sf2-1) ;
        if (flag2) 
        {
           *sf3= pi2hold*( spec3term*idterm + *(sf3-1)*r);
           *sf6= pi2hold *r *( *(sf4-1) + *(sf6-1) );
        }
        else 
        {
            *sf3=pi2hold*spec3term*idterm;
            *sf6=0.0;
         }
         if ( s1track==seqlength1) 
         {
            if (flag2) 
               tg3 = (*(sum-1)*0.5+tg3)*tgap*pi2hold;
            else 
               tg3= 0.5*(*(sum-1))*tgap*pi2hold;
         }
         if (s2track==seqlength2)
         {
            if (flag1) 
               tg2 = (0.5*oldsum+ tg2)*tgap*pi1hold;
            else 
               tg2= oldsum*tgap*pi1hold*0.5;
         }

         if (oldee1 != oldee2 || oldee1 != oldee3)
         {
            eemin = min3(oldee1,oldee2,oldee3);
            eemax = max3(oldee1,oldee2,oldee3);
            if (eemax-eemin > twojumps) 
            {
               printf("trouble !!\n");
            }
            if (oldee1 == eemin)  
            {
               *sf1 *= magnify;
               *sf4 *= magnify;
               *sf7 *= magnify;
            }
            if (oldee2 == eemin)
            {
               *sf2 *= magnify;
               *sf5 *= magnify;
               if (s2track==seqlength2) 
                  tg2 *=magnify;
            }
            if (oldee3 == eemin)
            {
               *sf3 *= magnify;
               *sf6 *= magnify;
               if (s1track==seqlength1) 
                  tg3 *= magnify;
            }
            *ee = eemin + twojumps;
         }  
         *sum= *sf1+ *sf2+ *sf3 + *sf4 + *sf5 + *sf6 + *sf7;
         tsum= *sum;
         if ( s2track==seqlength2) 
            tsum += tg2;
         if ( s1track==seqlength1) 
            tsum += tg3;
         if ( tsum < micronum)
         {
            *ee += twojumps;
            *sum *= magnify;
            *sf1 *= magnify;
            *sf2 *= magnify;
            *sf3 *= magnify;
            *sf4 *= magnify;
            *sf5 *= magnify;
            *sf6 *= magnify;
            *sf7 *= magnify;
            if (s2track==seqlength2) 
               tg2 *= magnify;
            if (s1track==seqlength1) 
               tg3 *= magnify;
         }
         else 
         {
            if ( tsum > magnify)
            {
               *ee -= twojumps;
               *sum *= microfy;
               *sf1 *= microfy;
               *sf2 *= microfy;
               *sf3 *= microfy;
               *sf4 *= microfy;
               *sf5 *= microfy;
               *sf6 *= microfy;
               *sf7 *= microfy;
               if (s2track==seqlength2) 
                  tg2 *= microfy;
               if (s1track==seqlength1) 
                  tg3 *= microfy;
            }
         }

         rold4=old4;
         rold1=old1;
         rold7=old7;
         oldee1=oldee2;
      } 
      ee=lee;
      sf1=lsf1;
      sf2=lsf2;
      sf3=lsf3;
      sf4=lsf4;
      sf5=lsf5;
      sf6=lsf6;
      sf7=lsf7;
      for(s2track=0;s2track<=seqlength2;s2track++)
      {
         fill[0][s1place][s2track]= *sf1;
         fill[1][s1place][s2track]= *sf2;
         fill[2][s1place][s2track]= *sf3;
         fill[3][s1place][s2track]= *sf4;
         fill[4][s1place][s2track]= *sf5;
         fill[5][s1place][s2track]= *sf6;
         fill[6][s1place][s2track]= *sf7;
         pee[s1place][s2track]= *ee;
         ee++;
         sf1++;
         sf2++;
         sf3++;
         sf4++;
         sf5++;
         sf6++;
         sf7++;
      }
      filltg[1][s1place]=tg2;
      filltg[0][s1place]=tg1;
   }

   if (bstart==0) 
   {
      freedvec(ltg0,seqlength2);
   }
   freeivec(lee,seqlength2);
   freedvec(lsf1,seqlength2);
   freedvec(lsf2,seqlength2);
   freedvec(lsf3,seqlength2);
   freedvec(lsf4,seqlength2);
   freedvec(lsf5,seqlength2);
   freedvec(lsf6,seqlength2);
   freedvec(lsf7,seqlength2);
   freedvec(lsum,seqlength2);
}

